# debuginfo-without-sources
%define debug_package %{nil}
%define rev git20131008

Summary: MSEide+MSEgui Free Pascal Cross Platform GUI Development System
Name: mseide-msegui
Version: 3.1
Release: %mkrel -c %{rev} 7
License: LGPLv2 with modification, GPLv2
Group: Development/Tools
Url: http://sourceforge.net/projects/mseide-msegui
# https://gitorious.org/mseide-msegui/mseide-msegui/archive/93646dcda58389f2aa9ecbd0e1cccbaef0896706.tar.gz
Source0: %{name}-%{version}-%{rev}.zip
Source1: mseide.desktop
Source2: mseide
Source3: mseide_i18n.tar.gz
Source4: msei18n_i18n.tar.gz
Source5: msei18n.desktop
Source6: msei18n
# Additional template with auto determine locale
Source7: project_all_langs.pas
# For hot localization started mseide (upstream: ignored by author)
Patch1: %{name}-%{version}-mga-hot-i18n.patch
# For support all available translations (upstream: author don't want to enable by default)
Patch2: %{name}-%{version}-mga-localization.patch
BuildRequires: pkgconfig(x11)
BuildRequires: fpc
Requires: pkgconfig(x11)
Requires: fpc
Requires: gdb

%description
Free Pascal-based GUI development library and IDE.
The MSEide is a Cross Platform GUI Development System for Pascal programmers,
completely written in Pascal. The MSEgui does not feature VCL compatibility.
The graphics library provides an interface to win32 and X11. Despite being a
single person (Martin Schreiber) effort for the moment, the IDE and GUI has
already an amazing feature list:
- Internal character encoding is UCS2.
- Internationalization tool included.
- Docking forms.
- Embedded forms (similar to TFrame).
- Visual form inheritance.
- Links to xlib and gdi32, no external widget library needed.
- Database access components and data edit widgets.
- Integrated debugging.
- Integrated report designer.
- Flexible and handy build system with switchable macros.
- and more...

%package i18n
Summary: Translations for %{name}
License: GPLv2
Requires: %{name} = %{version}

%description i18n
This package contains international support for %{name}. If it is not
installed, %{name} will be available in English only.

%prep
%setup -q -n msegui
%autopatch -p1
pushd apps/ide
     tar xvzf %{SOURCE3}
popd
pushd tools/i18n
     tar xvzf %{SOURCE4}
popd
# FIXME Fix executable
chmod -x apps/ide/syntaxdefs/cpp.sdef
chmod -x lib/common/kernel/windows/msesocketintf.pas
# FIXME Clean
find ./ -name '*.pas~' -delete
# Create additional template with auto determine locale
cp -f %{SOURCE7} ./apps/ide/templates/default/
cp -f ./apps/ide/templates/default.prj ./apps/ide/templates/default_all_langs.prj
sed -i -e "s|project.pas|project_all_langs.pas|g" ./apps/ide/templates/default_all_langs.prj
# Delete licenses, use rpmbuild instead
find ./apps -name 'COPYING*' -delete
find ./lib -name 'COPYING*' -delete
find ./tools -name 'COPYING*' -delete
# Delete empty directories
rm -rf tools/doc
rm -rf tools/xft2gs

%build
BUILD_ARGS="-l -Mobjfpc -Sh -Fcutf8 -Fulib/common/* -Fulib/common/kernel/linux -Filib/common/kernel"
# Build mseide and msei18n
fpc $BUILD_ARGS apps/ide/mseide.pas
fpc $BUILD_ARGS tools/i18n/msei18n.pas
# Build bmp2pas and form2pas
fpc $BUILD_ARGS tools/bmp2pas
fpc $BUILD_ARGS tools/form2pas
# Build all available locales for mseide and msei18n
for LANG in ru
do
  fpc -Fu/common/* -Fulib/common/* apps/ide/lang_$LANG/i18n_$LANG.pas
  fpc -Fu/common/* -Fulib/common/* tools/i18n/lang_$LANG/i18n_$LANG.pas
  mv -vf apps/ide/lang_$LANG/libi18n_$LANG.so apps/ide/
  mv -vf tools/i18n/lang_$LANG/libi18n_$LANG.so tools/i18n/
done

%install
mkdir -p %{buildroot}%{_datadir}/%{name}
cp -rf apps %{buildroot}%{_datadir}/%{name}/
mkdir -p %{buildroot}%{_libdir}/%{name}
cp -rf lib/* %{buildroot}%{_libdir}/%{name}/
ln -s %{_libdir}/%{name} %{buildroot}%{_datadir}/%{name}/lib
cp -rf tools %{buildroot}%{_datadir}/%{name}/
mkdir -p %{buildroot}%{_datadir}/applications
install -m 644 %{SOURCE1} %{buildroot}%{_datadir}/applications/
install -m 644 %{SOURCE5} %{buildroot}%{_datadir}/applications/
mkdir -p %{buildroot}%{_bindir}
install -m 755 %{SOURCE2} %{buildroot}%{_bindir}
install -m 755 %{SOURCE6} %{buildroot}%{_bindir}
mkdir -p %{buildroot}%{_iconsdir}/hicolor/24x24/apps
install -m 644 msegui_24.png %{buildroot}%{_iconsdir}/hicolor/24x24/apps/mseide.png
mkdir -p %{buildroot}%{_iconsdir}/hicolor/32x32/apps
install -m 644 msegui_32.png %{buildroot}%{_iconsdir}/hicolor/32x32/apps/mseide.png
mkdir -p %{buildroot}%{_iconsdir}/hicolor/48x48/apps
install -m 644 msegui_48.png %{buildroot}%{_iconsdir}/hicolor/48x48/apps/mseide.png
mkdir -p %{buildroot}%{_iconsdir}/hicolor/64x64/apps
install -m 644 msegui_64.png %{buildroot}%{_iconsdir}/hicolor/64x64/apps/mseide.png
mkdir -p %{buildroot}%{_iconsdir}/scalable/apps
install -m 644 msegui.svg %{buildroot}%{_iconsdir}/scalable/apps/mseide.svg
install -m 644 tools/i18n/msei18n.ico %{buildroot}%{_iconsdir}/
ln -s %{_datadir}/%{name}/tools/bmp2pas %{buildroot}%{_bindir}/bmp2pas
ln -s %{_datadir}/%{name}/tools/form2pas %{buildroot}%{_bindir}/form2pas
# We stay *.o and *.ppu files in lib only
find %{buildroot}%{_datadir}/%{name}/apps \( -name "*.o" -o -name "*.ppu" \) -delete
find %{buildroot}%{_datadir}/%{name}/tools \( -name "*.o" -o -name "*.ppu" \) -delete
# mseide creates *.o and *.ppu files while compiling
# and needs read/write access for root and users
chmod -R 666 `find %{buildroot} \( -name "*.o" -o -name "*.ppu" \)`

%files
%doc COPYING.MSE DEBUG.TXT README.TXT VERSION.TXT ZEOS.TXT
%{_datadir}/%{name}
%{_libdir}/%{name}
%{_datadir}/applications/*.desktop
%{_bindir}/mseide
%{_bindir}/msei18n
%{_bindir}/bmp2pas
%{_bindir}/form2pas
%{_iconsdir}/msei18n.ico
%{_iconsdir}/hicolor/*/apps/*
%{_iconsdir}/scalable/apps/*
%exclude %{_datadir}/%{name}/apps/ide/libi18n_*.so
%exclude %{_datadir}/%{name}/tools/i18n/libi18n_*.so
%exclude %{_datadir}/%{name}/apps/ide/lang_*
%exclude %{_datadir}/%{name}/tools/i18n/lang_*

%files i18n
%{_datadir}/%{name}/apps/ide/libi18n_*.so
%{_datadir}/%{name}/tools/i18n/libi18n_*.so
%{_datadir}/%{name}/apps/ide/lang_*
%{_datadir}/%{name}/tools/i18n/lang_*


%changelog
* Tue Feb 09 2016 umeabot <umeabot> 3.1-0.git20131008.7.mga6
+ Revision: 951685
- Mageia 6 Mass Rebuild

* Wed Jan 07 2015 alexl <alexl> 3.1-0.git20131008.6.mga5
+ Revision: 809055
- updated desktop files
- fixed spelling error

* Wed Nov 12 2014 alexl <alexl> 3.1-0.git20131008.5.mga5
+ Revision: 796671
- fixed icon in desktop file

* Wed Oct 15 2014 umeabot <umeabot> 3.1-0.git20131008.4.mga5
+ Revision: 744075
- Second Mageia 5 Mass Rebuild

* Sun Sep 28 2014 umeabot <umeabot> 3.1-0.git20131008.3.mga5
+ Revision: 731501
- Mageia 5 Mass Rebuild

* Mon Apr 21 2014 alexl <alexl> 3.1-0.git20131008.2.mga5
+ Revision: 617290
- fixed French localization (localization patch)
- added tools: bmp2pas, form2pas
- used 666 permissions for *.o and *.ppu files instead of 777 for directories
- included *.o and *.ppu files in RPM
- fix icon's installation with according resolution

* Mon Apr 21 2014 alexl <alexl> 3.1-0.git20131008.1.mga5
+ Revision: 617204
- imported package mseide-msegui

